---
title: Array.prototype.forEach()
slug: Web/JavaScript/Reference/Global_Objects/Array/forEach
tags:
  - Array
  - ECMAScript 5
  - JavaScript
  - Method
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p>The <code><strong>forEach()</strong></code> method executes a provided function once for each array element.</p>

<div>{{EmbedInteractiveExample("pages/js/array-foreach.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>arr</var>.forEach(<var>callback(currentValue[, index[, array]]) {
</var>  // execute something
<var>}</var>[, <var>thisArg</var>]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>callback</var></code></dt>
 <dd>Function to execute on each element. It accepts between one and three arguments:</dd>
 <dd>
 <dl>
  <dt><code><var>currentValue</var></code></dt>
  <dd>The current element being processed in the array.</dd>
  <dt><code><var>index</var></code> {{optional_inline}}</dt>
  <dd>The index of <code><var>currentValue</var></code> in the array.</dd>
  <dt><code><var>array</var></code> {{optional_inline}}</dt>
  <dd>The array <code>forEach()</code> was called upon.</dd>
 </dl>
 </dd>
 <dt><code><var>thisArg</var></code> {{optional_inline}}</dt>
 <dd>Value to use as <code>this</code> when executing <code><var>callback</var></code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h2 id="Description">Description</h2>

<p><code>forEach()</code> calls a provided <code><var>callback</var></code> function once for each element in an array in ascending order. It is not invoked for index properties that have been deleted or are uninitialized. (For sparse arrays, <a href="#sparseArray">see example below</a>.)</p>

<p><code><var>callback</var></code> is invoked with three arguments:</p>

<ol>
 <li>the value of the element</li>
 <li>the index of the element</li>
 <li>the Array object being traversed</li>
</ol>

<p>If a <code><var>thisArg</var></code> parameter is provided to <code>forEach()</code>, it will be used as callback's <code>this</code> value. The <code><var>thisArg</var></code> value ultimately observable by <code><var>callback</var></code> is determined according to <a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">the usual rules for determining the <code>this</code> seen by a function</a>.</p>

<p>The range of elements processed by <code>forEach()</code> is set before the first invocation of <code><var>callback</var></code>. Elements which are appended to the array after the call to <code>forEach()</code> begins will not be visited by <code><var>callback</var></code>. If existing elements of the array are changed or deleted, their value as passed to <code><var>callback</var></code> will be the value at the time <code>forEach()</code> visits them; elements that are deleted before being visited are not visited. If elements that are already visited are removed (e.g. using {{jsxref("Array.prototype.shift()", "shift()")}}) during the iteration, later elements will be skipped. (<a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/forEach#Modifying_the_array_during_iteration">See this example, below</a>.)</p>

<p><code>forEach()</code> executes the <code><var>callback</var></code> function once for each array element; unlike {{jsxref("Array.prototype.map()", "map()")}} or {{jsxref("Array.prototype.reduce()", "reduce()")}} it always returns the value {{jsxref("undefined")}} and is not chainable. The typical use case is to execute side effects at the end of a chain.</p>

<p><code>forEach()</code> does not mutate the array on which it is called. (However, <code><var>callback</var></code> may do so)</p>

<div class="note">
<p>There is no way to stop or break a <code>forEach()</code> loop other than by throwing an exception. If you need such behavior, the <code>forEach()</code> method is the wrong tool.</p>

<p>Early termination may be accomplished with:</p>

<ul>
 <li>A simple <a href="/en-US/docs/Web/JavaScript/Reference/Statements/for">for</a> loop</li>
 <li>A <a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of">for...of</a> / <a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...in">for...in</a> loops</li>
 <li>{{jsxref("Array.prototype.every()")}}</li>
 <li>{{jsxref("Array.prototype.some()")}}</li>
 <li>{{jsxref("Array.prototype.find()")}}</li>
 <li>{{jsxref("Array.prototype.findIndex()")}}</li>
</ul>

<p>Array methods: {{jsxref("Array.prototype.every()", "every()")}}, {{jsxref("Array.prototype.some()", "some()")}}, {{jsxref("Array.prototype.find()", "find()")}}, and {{jsxref("Array.prototype.findIndex()", "findIndex()")}} test the array elements with a predicate returning a truthy value to determine if further iteration is required.</p>
</div>

<div class="note">
<h4 id="forEach_expects_a_synchronous_function">forEach expects a synchronous function</h4>
<code>forEach</code> does not wait for promises. Kindly make sure you are aware of the implications while using promises(or async functions) as <code>forEach</code> callback.

<h5 id="Example_Code">Example Code</h5>

<pre class="brush: js notranslate">let ratings = [5, 4, 5];
let sum = 0;

let sumFunction = async function (a, b)
{
  return a + b
}

ratings.forEach(async function(rating) {
  sum = await sumFunction(sum, rating)
})

console.log(sum)
// Naively expected output: 14
// Actual output: 0
</pre>
</div>

<h2 id="Polyfill">Polyfill</h2>

<p><code>forEach()</code> was added to the ECMA-262 standard in the 5<sup>th</sup> edition, and it may not be present in all implementations of the standard. You can work around this by inserting the following code at the beginning of your scripts, allowing use of <code>forEach<font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">()</span></font></code> in implementations which do not natively support it.</p>

<p>This algorithm is exactly the one specified in ECMA-262, 5<sup>th</sup> edition, assuming {{jsxref("Object")}} and {{jsxref("TypeError")}} have their original values and that <code><var>fun</var>.call</code> evaluates to the original value of {{jsxref("Function.prototype.call()")}}.</p>

<pre class="brush: js notranslate">// Production steps of ECMA-262, Edition 5, 15.4.4.18
// Reference: https://es5.github.io/#x15.4.4.18

if (!Array.prototype['forEach']) {

  Array.prototype.forEach = function(callback, thisArg) {

    if (this == null) { throw new TypeError('Array.prototype.forEach called on null or undefined'); }

    var T, k;
    // 1. Let O be the result of calling toObject() passing the
    // |this| value as the argument.
    var O = Object(this);

    // 2. Let lenValue be the result of calling the Get() internal
    // method of O with the argument "length".
    // 3. Let len be toUint32(lenValue).
    var len = O.length &gt;&gt;&gt; 0;

    // 4. If isCallable(callback) is false, throw a TypeError exception.
    // See: https://es5.github.com/#x9.11
    if (typeof callback !== "function") { throw new TypeError(callback + ' is not a function'); }

    // 5. If thisArg was supplied, let T be thisArg; else let
    // T be undefined.
    if (arguments.length &gt; 1) { T = thisArg; }

    // 6. Let k be 0
    k = 0;

    // 7. Repeat, while k &lt; len
    while (k &lt; len) {

      var kValue;

      // a. Let Pk be ToString(k).
      //    This is implicit for LHS operands of the in operator
      // b. Let kPresent be the result of calling the HasProperty
      //    internal method of O with argument Pk.
      //    This step can be combined with c
      // c. If kPresent is true, then
      if (k in O) {

        // i. Let kValue be the result of calling the Get internal
        // method of O with argument Pk.
        kValue = O[k];

        // ii. Call the Call internal method of callback with T as
        // the this value and argument list containing kValue, k, and O.
        callback.call(T, kValue, k, O);
      }
      // d. Increase k by 1.
      k++;
    }
    // 8. return undefined
  };
}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="sparseArray">No operation for uninitialized values (sparse arrays)</h3>

<pre class="brush: js notranslate">const arraySparse = [1,3,,7]
let numCallbackRuns = 0

arraySparse.forEach(function(element) {
  console.log(element)
  numCallbackRuns++
})

console.log("numCallbackRuns: ", numCallbackRuns)

// 1
// 3
// 7
// numCallbackRuns: 3
// comment: as you can see the missing value between 3 and 7 didn't invoke callback function.</pre>

<h3 id="Converting_a_for_loop_to_forEach">Converting a for loop to forEach</h3>

<pre class="brush:js notranslate">const items = ['item1', 'item2', 'item3']
const copyItems = []

// before
for (let i = 0; i &lt; items.length; i++) {
  copyItems.push(items[i])
}

// after
items.forEach(function(item){
  copyItems.push(item)
})
</pre>

<h3 id="Printing_the_contents_of_an_array">Printing the contents of an array</h3>

<div class="notecard note">
<p><strong>Note:</strong> In order to display the content of an array in the console, you can use {{domxref("Console/table", "console.table()")}}, which prints a formatted version of the array.</p>

<p>The following example illustrates an alternative approach, using <code>forEach()</code>.</p>
</div>

<p>The following code logs a line for each element in an array:</p>

<pre class="brush:js notranslate">function logArrayElements(element, index, array) {
  console.log('a[' + index + '] = ' + element)
}

// Notice that index 2 is skipped, since there is no item at
// that position in the array...
[2, 5, , 9].forEach(logArrayElements)
// logs:
// a[0] = 2
// a[1] = 5
// a[3] = 9
</pre>

<h3 id="Using_thisArg">Using thisArg</h3>

<p>The following (contrived) example updates an object's properties from each entry in the array:</p>

<pre class="brush:js notranslate">function Counter() {
  this.sum = 0
  this.count = 0
}
Counter.prototype.add = function(array) {
  array.forEach(function countEntry(entry) {
    this.sum += entry
    ++this.count
  }, this)
}

const obj = new Counter()
obj.add([2, 5, 9])
obj.count
// 3
obj.sum
// 16
</pre>

<p>Since the <code><var>thisArg</var></code> parameter (<code>this</code>) is provided to <code>forEach()</code>, it is passed to <code><var>callback</var></code> each time it's invoked. The callback uses it as its <code>this</code> value.</p>

<div class="note">
<p><strong>Note:</strong> If passing the callback function used an <a href="/en-US/docs/Web/JavaScript/Reference/Functions/Arrow_functions">arrow function expression</a>, the <code><var>thisArg</var></code> parameter could be omitted, since all arrow functions lexically bind the {{jsxref("Operators/this", "this")}} value.</p>
</div>

<h3 id="An_object_copy_function">An object copy function</h3>

<p>The following code creates a copy of a given object.</p>

<p>There are different ways to create a copy of an object. The following is just one way and is presented to explain how <code>Array.prototype.forEach()</code> works by using ECMAScript 5 <code>Object.*</code> meta property functions.</p>

<pre class="brush: js notranslate">function copy(obj) {
  const copy = Object.create(Object.getPrototypeOf(obj))
  const propNames = Object.getOwnPropertyNames(obj)

  propNames.forEach(function(name) {
    const desc = Object.getOwnPropertyDescriptor(obj, name)
    Object.defineProperty(copy, name, desc)
  })

  return copy
}

const obj1 = { a: 1, b: 2 }
const obj2 = copy(obj1) // obj2 looks like obj1 now
</pre>

<h3 id="Modifying_the_array_during_iteration">Modifying the array during iteration</h3>

<p>The following example logs <samp>one</samp>, <samp>two</samp>, <samp>four</samp>.</p>

<p>When the entry containing the value <code>two</code> is reached, the first entry of the whole array is shifted off—resulting in all remaining entries moving up one position. Because element <code>four</code> is now at an earlier position in the array, <code>three</code> will be skipped.</p>

<p><code>forEach()</code> does not make a copy of the array before iterating.</p>

<pre class="brush:js notranslate">let words = ['one', 'two', 'three', 'four']
words.forEach(function(word) {
  console.log(word)
  if (word === 'two') {
    words.shift() //'one' will delete from array
  }
}) // one // two // four

console.log(words);  //['two', 'three', 'four']

</pre>

<h3 id="Flatten_an_array">Flatten an array</h3>

<p>The following example is only here for learning purpose. If you want to flatten an array using built-in methods you can use {{jsxref("Array.prototype.flat()")}}.</p>

<pre class="brush: js notranslate">function flatten(arr) {
  const result = []

  arr.forEach(function(i) {
    if (Array.isArray(i)) {
      result.push(...flatten(i))
    } else {
      result.push(i)
    }
  })

  return result
}

// Usage
const nested = [1, 2, 3, [4, 5, [6, 7], 8, 9]]

flatten(nested) // [1, 2, 3, 4, 5, 6, 7, 8, 9]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-array.prototype.foreach', 'Array.prototype.forEach')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Array.forEach")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.find()")}}</li>
 <li>{{jsxref("Array.prototype.findIndex()")}}</li>
 <li>{{jsxref("Array.prototype.map()")}}</li>
 <li>{{jsxref("Array.prototype.filter()")}}</li>
 <li>{{jsxref("Array.prototype.every()")}}</li>
 <li>{{jsxref("Array.prototype.some()")}}</li>
 <li>{{jsxref("Map.prototype.forEach()")}}</li>
 <li>{{jsxref("Set.prototype.forEach()")}}</li>
</ul>
